package de.fhdw.wtf.tooling.commands;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.handlers.HandlerUtil;

public abstract class AbstractWTFClickHandler extends AbstractHandler {
	
	@Override
	public Object execute(final ExecutionEvent event) throws ExecutionException {
		final Shell shell = HandlerUtil.getActiveShell(event);
		final IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getActiveMenuSelection(event);
		final Object firstElement = selection.getFirstElement();
		if (firstElement instanceof IJavaProject) {
			this.executeTransitive(event, (IJavaProject) firstElement);
		} else {
			MessageDialog.openInformation(shell, "Info", "Please select a Java project");
		}
		return null;
	}
	
	/**
	 * Executes with the map of parameter values by name and the selected {@link IJavaProject}.
	 * 
	 * @param event
	 * @param javaProject
	 * @throws ExecutionException
	 */
	protected abstract void executeTransitive(ExecutionEvent event, IJavaProject javaProject) throws ExecutionException;
	
}
