package de.fhdw.wtf.tooling.editor;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.MultiLineRule;
import org.eclipse.jface.text.rules.RuleBasedPartitionScanner;
import org.eclipse.jface.text.rules.Token;

public class WTFPartitionScanner extends RuleBasedPartitionScanner {
	public static final String WTF_PARTITIONER = "__wtf_partitioner__";
	public static final String WTF_COMMENT_PARTITION = "wtf_comment";
	
	private static WTFPartitionScanner instance;
	
	public static synchronized WTFPartitionScanner getInstance() {
		if (instance == null) {
			instance = new WTFPartitionScanner();
		}
		return instance;
	}
	
	public WTFPartitionScanner() {
		super();
		final IToken wtfComment = new Token(WTF_COMMENT_PARTITION);
		final List<IPredicateRule> rules = new ArrayList<>();
		rules.add(new MultiLineRule("#", "#", wtfComment));
		final IPredicateRule[] result = new IPredicateRule[rules.size()];
		rules.toArray(result);
		this.setPredicateRules(result);
	}
	
}
