package de.fhdw.wtf.tooling.wizard;

import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.dialogs.WizardNewProjectCreationPage;

public class WTFWizard extends WizardNewProjectCreationPage {
	
	private Text topPackageName = null;
	private Text oracleHostname = null;
	private Text oraclePort = null;
	private Text oracleUsername = null;
	private Text oraclePassword = null;
	private Text oracleShema = null;
	
	public WTFWizard(final String pageName) {
		super(pageName);
	}
	
	@Override
	public void createControl(final Composite parent) {
		super.createControl(parent);
		
		final Composite masterControl = (Composite) this.getControl();
		final Composite control = new Composite(masterControl, SWT.NONE);
		control.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		control.setLayout(new GridLayout(2, false));
		
		final Label l11 = new Label(control, SWT.LEFT);
		l11.setText("Project Group Name (e.g. \"com>yourcompany>yourproject\")");
		this.topPackageName = new Text(control, SWT.BORDER);
		this.topPackageName.addKeyListener(new KeyListener() {
			@Override
			public void keyReleased(final KeyEvent e) {
				WTFWizard.this.setPageComplete(WTFWizard.this.validatePage());
			}
			
			@Override
			public void keyPressed(final KeyEvent e) {
				// nothing to do
			}
		});
		final Label l2 = new Label(control, SWT.LEFT);
		l2.setText("Oracle Database Host");
		this.oracleHostname = new Text(control, SWT.BORDER);
		this.oracleHostname.setText("localhost");
		final Label l3 = new Label(control, SWT.LEFT);
		l3.setText("Oracle Database Port");
		this.oraclePort = new Text(control, SWT.BORDER);
		this.oraclePort.setText("1521");
		final Label l4 = new Label(control, SWT.LEFT);
		l4.setText("Username");
		this.oracleUsername = new Text(control, SWT.BORDER);
		this.oracleUsername.addKeyListener(new KeyListener() {
			@Override
			public void keyReleased(final KeyEvent e) {
				WTFWizard.this.oracleShema.setText(WTFWizard.this.oracleUsername.getText());
			}
			
			@Override
			public void keyPressed(final KeyEvent e) {
				// nothing to do
			}
		});
		final Label l5 = new Label(control, SWT.LEFT);
		l5.setText("Password");
		this.oraclePassword = new Text(control, SWT.BORDER | SWT.PASSWORD);
		final Label l6 = new Label(control, SWT.LEFT);
		l6.setText("Schema Name");
		this.oracleShema = new Text(control, SWT.BORDER);
		this.setPageComplete(false);
	}
	
	@Override
	protected boolean validatePage() {
		return super.validatePage() && this.isModelFileNameSet() && this.isTopLevelPackageNameSet();
	}
	
	private boolean isModelFileNameSet() {
		return true;
	}
	
	private boolean isTopLevelPackageNameSet() {
		return this.topPackageName.getText() != null && !this.topPackageName.getText().isEmpty();
	}
	
	public String getModelFileName() {
		return "model";
	}
	
	public String getTopLevelPackageName() {
		return this.topPackageName.getText();
	}
	
	public Properties getOracleProps() {
		final Properties result = new Properties();
		result.put("hostname", this.oracleHostname.getText());
		result.put("port", this.oraclePort.getText());
		result.put("username", this.oracleUsername.getText());
		result.put("password", this.oraclePassword.getText());
		result.put("schema", this.oracleShema.getText());
		result.put("sid", "xe");
		return result;
	}
	
}
